/// <reference types="grecaptcha" />
import { AfterViewInit, EventEmitter, NgZone, OnDestroy } from '@angular/core';
import { RecaptchaLoaderService } from './recaptcha-loader.service';
export declare class RecaptchaComponent implements AfterViewInit, OnDestroy {
    private loader;
    private zone;
    id: string;
    siteKey: string;
    theme: ReCaptchaV2.Theme;
    type: ReCaptchaV2.Type;
    size: ReCaptchaV2.Size | 'invisible';
    tabIndex: number;
    resolved: EventEmitter<string>;
    constructor(loader: RecaptchaLoaderService, zone: NgZone);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    /**
     * Executes the invisible recaptcha.
     * Does nothing if component's size is not set to "invisible".
     */
    execute(): void;
    reset(): void;
}
